// monom.h - Klasa monoma.

#ifndef _monom_h_
#define _monom_h_

#include "fun3.h"
#include <cmath>
using namespace std;

namespace Izvodi {
  class Monom: public Fun {
    double a, b;                           // Prametri monoma.
    void pisi (ostream& it) const          // Pisanje.
      { it << a << "*x^" << b; }
  public:
    Monom (double aa=1, double bb=1)       // Inicijalizacija.
      { a = aa; b = bb; }
    double operator() (double x) const     // Racunanje vrednosti.
      { return a * pow (x, b); }
    GFun izvod () const                    // Stvaranje izvoda.
      { return GFun (new Monom (a*b, b-1)); }
    Monom* kopija () const                 // Stvaranje dinamicke kopije.
      { return new Monom (*this); }
  }; // class Monom
} // namespace Izvodi

#endif
