// nizkompl.h - Definicija klase nizova kompleksnih brojeva.

#include "kompl1.h"

class NizKompl {
  int n; Kompl* niz;   // Duzina i pokazivac na elemente.
  void kopiraj (const NizKompl&);            // Kopiranje.
  void brisi () { delete [] niz; }           // Unistavanje.
public:                                      // Konstruktori:
  explicit NizKompl (int d=10)               // - podrazumevani,
    { niz = new Kompl [n = d]; }
  NizKompl (const NizKompl &nk)              // - kopije.
    { kopiraj (nk); }
  ~NizKompl () { brisi (); }                 // Destruktor.
  NizKompl& operator= (const NizKompl& nk) { // Dodela vrednosti.
    if (this != &nk) { brisi (); kopiraj (nk); }
    return *this;
  }
  int duz () const { return n; }
                                             // Element niza:
  Kompl& operator[] (int i)                  // - promenljivog,
    { return niz[i]; }
  const Kompl& operator[] (int i) const      // - nepromenljivog.
    { return niz[i]; }
};
