// predmet2.h - Klasa apstraktnih predmeta.

#ifndef _predmet2_h_
#define _predmet2_h_

#include <iostream>
using namespace std;

namespace Zbirke {
  class Predmet {
    static int ukId; // Poslednje korisceni identifikacioni broj.
    int id;          // Identifikacioni broj predmeta.
  public:
    Predmet () { id = ++ukId; }      // Nov predmet dobija nov broj.
    Predmet (const Predmet&)         // Kopija dobija nov broj.
      { id = ++ukId; }
    virtual ~Predmet () {}                // Virtuelan destruktor.
    Predmet& operator= (const Predmet&)   // Levom operandu se
      { return *this; }                   //   ne menja broj.
    int idBr () const { return id; }      // Identifikacioni broj.
    virtual Predmet* kopija () const =0;  // Dinamicka kopija.
  private:
    virtual void pisi(ostream &it) const =0;   // Pisanje.
    friend ostream& operator<< (ostream& it, const Predmet& p)
      { p.pisi (it); return it; }
  };
} // namespace

#endif
