// selekcija.h - Klasa selekcija.

#ifndef _selekcija_h_
#define _selekcija_h_

#include "izraz.h"
using namespace Izrazi;
#include "naredba.h"

namespace Naredbe {
  class Selekcija: public Naredba {
    Izraz* izr;                         // Uslov selekcije.
    Naredba *nar1, *nar2;               // Uslovno izvrsavane naredbe.
    void kopiraj (const Selekcija& s) { // Kopiranje u objekat.
      izr  = s.izr ->kopija ();
      nar1 = s.nar1->kopija ();
      nar2 = s.nar2->kopija ();
    }
    void brisi ()                       // Oslobadjanje memorije.
      { delete izr; delete nar1; delete nar2; }
    void pisi (ostream& it) const {     // Pisanje.
      Naredba::pisi (it); it << "if(" << *izr << ")\n";
      nivo++; it << *nar1; nivo--;
      Naredba::pisi (it); it << "else\n";
      nivo++; it << *nar2; nivo--;
    }
  public:                                           // Inicijalizacija.
    Selekcija (const Izraz& i, const Naredba& n1, const Naredba& n2)
      { izr = i.kopija (); nar1 = n1.kopija (); nar2 = n2.kopija (); }
    Selekcija (const Selekcija& s) { kopiraj (s); } // Konstruktor kopije.
    ~Selekcija () { brisi (); }                     // Unistavanje.
    Selekcija& operator= (const Selekcija& s) {     // Dodela vrednosti.
      if (this != &s) { brisi (); kopiraj (s); }
      return *this;
    }
    void radi () const                              // Izvrsavanje.
      { if (izr->vredn()) nar1->radi (); else nar2->radi (); }
    Selekcija* kopija() const { return new Selekcija(*this); } // Din. kop.
  }; // class Selekcija
} // namespace Naredbe

#endif 